package com.didana.codecontract.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * An annotation that supports Design by Contract tests.
 * Classes that define tests must be annotated with @Contract.
 * The tests are specified using the @Pre, @Post, and @Invar
 * annotations for "precondition", "postcondition", and "invariant" tests,
 * respectively. 
 * 
 * @author Diana Berberova
 * 
 */
@Documented
@Inherited
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.TYPE, ElementType.ANNOTATION_TYPE})
public @interface Contract {}
