package com.didana.codecontract.core;

/**
 * 
 * This is runtime exception thrown when an error 
 * occurs during the runtime check of contracts.
 *  
 * @author Diana Berberova
 *
 */
public class ContractException extends RuntimeException {
    public static final String CANNOT_GET_INVARIANTS = "Cannot get invariants of class.";
    public static final String CONTRACT_ANNOTATION_MISSING = "The class does not have declared 'dbc.annotation.Contract' annotation.";
    public static final String ANNOTATED_METHOD_MISSING = "The annotated method does not exist in the class.";
    public static final String CANNOT_GET_METHOD_ANNOTATION_VALUE = "The value of the method annotation cannot be get.";
    public static final String CANNOT_GET_CONSTRUCTOR_ANNOTATION_VALUE = "The value of the constructor annotation cannot be get.";
    public static final String CANNOT_GET_METHOD_CONTRACTS = "Cannot get method contracts for parrent classes and interfaces.";
    public static final String CANNOT_GET_FIELDS = "Cannot get fields of class.";
    public static final String CANNOT_GET_FIELDS_ANNOTATION_VALUE = "The value of the field annotation cannot be get.";
    public static final String CANNOT_GET_METHODS = "Cannot get methods of class.";
    public static final String CANNOT_GET_METHODS_ANNOTATION_VALUE = "The value of the method annotation cannot be get.";
    public static final String CLASS_INSTANCE_NOT_INITIALIZED = "The class instance is null.";
    public static final String INVALID_ANNOTATION = "The type of annotatipn passed is not valid. It must be Pre or Post annotation.";
    
    private static final long serialVersionUID = 0x74f6fd0bd9508ad0L;
    private Exception exception;
    private String message;

    public ContractException(String message)
    {
        this.message = message;
        exception = null;
    }

    public ContractException(Exception e)
    {
        message = null;
        exception = e;
    }

    public ContractException(String message, Exception e)
    {
        this.message = message;
        exception = e;
    }

    public String getMessage()
    {
        if(message == null && exception != null) {
            return exception.getMessage();
        } else {
            return message;
        }
    }
    
    public String getInnerMessage()
    {
        if(exception != null) {
            return exception.getMessage();
        } else {
            return null;
        }
    }

    public Exception getException()
    {
        return exception;
    }


}
