package com.didana.codecontract.tests;

import com.didana.codecontract.annotation.*;

/**
 * Interface used for testing contract inheritance.
 *  
 * @author Diana Berberova
 *
 */
@Contract
public interface Animal {

	@Invar ("speciesName.equals('Animal')")
	public String speciesName = "Animal";
		
	public String getSpeciesName();
	
	public int getNumberOfLegs();
	
	@Pre ("$args0 >= 0")
	public void setNumberOfLegs(int number);
	
	@Post ("$return.startsWith('Animal')")
	public String getFullName();
	
}
