package com.didana.codecontract.tests;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.HashMap;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import com.didana.codecontract.core.ExpressionHandler;

/**
 * JUnit test case for testing ExpressionHandler methods.
 * 
 * @author Diana Berberova
 *
 */
public class ExpressionHandlerTest {

	private static ArrayList<String> expressions1 = new ArrayList<String>();
	private static HashMap<String, Object> arguments1 = new HashMap<String, Object>();


	private static ArrayList<String> expressions2 = new ArrayList<String>();
	private static HashMap<String, Object> arguments2 = new HashMap<String, Object>();

	private static ArrayList<String> expressions3 = new ArrayList<String>();
	private static HashMap<String, Object> arguments3 = new HashMap<String, Object>();

	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {

		expressions1.add("stringValue.startsWith('a')");
		expressions1.add("stringValue != null");
		expressions1.add("intValue >= 0");
		
		arguments1.put("stringValue", "aaaa");
		arguments1.put("intValue", 0);
		
		
		expressions2.add("stringValue.startsWith('a')");
		expressions2.add("stringValue != null");
		expressions2.add("intValue >= 0");
		
		arguments2.put("stringValue", "aaaa");
		arguments2.put("intValue", -1);
		
		
		expressions3.add("stringValue.startsWith('a')");
		expressions3.add("stringValue != null");
		expressions3.add("intValue >= 0");
		
		arguments3.put("stringValue", "aaaa");
	
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Test
	public void testEvaluateExpressions1() {
		ExpressionHandler expressionHandler = new ExpressionHandler(expressions1, arguments1);
		boolean result = expressionHandler.evaluateExpressions();
		assertEquals("Expression evaluation failed", true, result);
	}

	@Test
	public void testEvaluateExpressions2() {
		ExpressionHandler expressionHandler = new ExpressionHandler(expressions2, arguments2);
		boolean result = expressionHandler.evaluateExpressions();
		assertEquals("Expression evaluation failed", false, result);
	}
	
	@Test
	public void testEvaluateExpressions3() {
		ExpressionHandler expressionHandler = new ExpressionHandler(expressions3, arguments3);
		boolean result = expressionHandler.evaluateExpressions();
		assertEquals("Expression evaluation failed", false, result);
	}
}
