package com.didana.codecontract.tests;

import com.didana.codecontract.annotation.*;

/**
 * Class used for testing contract inheritance. 
 * 
 * @author Diana Berberova
 *
 */
@Contract 
public class Human extends Mammal implements Terrestrial {

	private String humanName;
	
	@Pre ("isConstructorPre == true")
	public Human() {
	}	
	
	@Post ("isConstructorPost == true")
	public Human(String name) {
	}
	
	@Invar ("numberTeeth >= 0 && numberTeeth <= 32")
	public int numberTeeth;  
	
	public String getHumanName() {
		return humanName;
	}	
	
	@Pre ("$args0 != null && $args1 != ''")
	@Post ("subspeciesName.equals('Mammal')")
	public void setHumanName(String humanName) {
		this.humanName = humanName;
	}
	
	public void setNumberTeeth(int numberTeeth) {
		this.numberTeeth = numberTeeth;
	}
	
	public int getNumberTeeth() {
		return numberTeeth;
	}
	
	@Post ("$return.endsWith('Human')")
	public String getFullName() {
		return "Animal-Mammal-Human";		
	}

	@Pre ("isPrivate == true")
	private void privateSet() {
		
	}
	
	@Post ("isProtected == true")
	protected void protectedSet() {
		
	}

	@Post ("isPackage == true")
	void packageSet() {
		
	}
	
	@Pre ("isStaticPre == true")
	@Post ("isStaticPost == true")
	public void staticSet() {
		
	}

	public void setDescription(String description) {
	
	}
}
