package com.didana.codecontract.tests;

import com.didana.codecontract.annotation.*;

/**
 * Class used for testing contract inheritance. 
 * 
 * @author Diana Berberova
 *
 */
@Contract
public abstract class Mammal implements Animal{

	public String subspeciesName = "Mammal";
	
	private int legs;
	private int fingers;
	
	@Invar ("description != null && description != ''")
	public String description = "The mammals are the class of vertebrate animals characterized by the production of milk in females for the nourishment of young.";
		
	public String getSubspeciesName() {
		return subspeciesName;		
	} 
		
	public String getSpeciesName() {
		return speciesName;		
	}

	public int getNumberOfLegs() {
		return legs;
	}
	
	public int getNumberOfFingers() {
		return fingers;
	}

	@Post ("fingers >= 0")
	public void setNumberOfFingers(int number) {
		fingers = number;
	}

	public void setNumberOfLegs(int number) {
		legs = number;		
	}

	@Post ("$return.indexOf('Mammal') > -1")
	public abstract String getFullName();
	
}
